﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Threading;

namespace pr240_1
{
    // Класс с методом для запуска в потоке: 
    class MyClass {
        // Закрытое текстовое поле: 
        private string text;
        // Закрытое целочисленное поле: 
        private int time;
        // Конструктор:
        public MyClass(string txt, int t) { 
            text = txt; 
            time = t;
        }
        // Метод без аргументов: 
        public void show(){
            for(int k = 1; k <= 5; k++){
                // Отображение сообщения: 
                Console.WriteLine(text + "\t" + k);
                // Задержка в выполнении потока: 
                Thread.Sleep(time);
            }
        }
    }

    // Главный класс: 
    class Program
    {
        // Статический метод с двумя аргументами: 
        static void run(string txt, int time) { 
            for(int k = 1; k <= 5; k++) {
                // Отображение сообщения: 
                Console.WriteLine(txt + "\t" + k);
                // Задержка в выполнении потока: 
                Thread.Sleep(time);
            }
        }
        // Главный метод: 
        static void Main()
        {
            // Начальное сообщение в главном потоке: 
            Console.WriteLine("Главный поток запущен..."); 
            // Создание объектов класса MyClass:
            MyClass A = new MyClass("Объект A", 1000);
            MyClass B = new MyClass("Объект B", 1500);
            // Создание экземпляра делегата:
            ThreadStart ts = A.show;
            // Добавление метода в список вызовов
            // экземпляра делегата: 
            ts += B.show;
            // Создание объекта потока на основе экземпляра 
            // делегата:
            Thread first = new Thread(ts);
            // Создание объекта потока на основе 
            // лямбда-выражения:
            Thread second = new Thread(() =>
            {
                run("Метод Alpha", 1200); 
                run("Метод Bravo", 800);
            });
            // Запуск первого потока: 
            first.Start();
            // Запуск второго потока: 
            second.Start();
            // Ожидание окончания выполнения первого потока: 
            if(first.IsAlive) first.Join();
            // Ожидание окончания выполнения второго потока: 
            if(second.IsAlive) second.Join();
            // Последнее сообщение в главном потоке:
            Console.WriteLine("Главный поток завершен...");
            // Задержка:
            Console.ReadLine();
        }
    }
}
